//
//  JGGbtn.m
//  长按抖动效果
//
//  Created by bz on 16/5/9.
//  Copyright © 2016年 济南博卒软件有限公司. All rights reserved.
//

#import "JGGbtn.h"
#define angelToRandian(x) ((x)/180.0*M_PI)
@implementation JGGbtn

#pragma mark--全局变量

//公用btn 用来将接受的btn 全局化使用
NSMutableArray*gongyongmarr;
//创建一个用来存放删除按钮的数组
NSMutableArray*shanchumarr;

#pragma mark--长按抖动方法
+(void)doudong:(NSMutableArray*)marr
{
    gongyongmarr=[[NSMutableArray alloc]init];
    shanchumarr=[[NSMutableArray alloc]init];
    gongyongmarr=marr;
    
    
    //将长按抖动效果给btn
    for (UIButton*btn in gongyongmarr) {
        UILongPressGestureRecognizer* longPress=[[UILongPressGestureRecognizer alloc]initWithTarget:self action:@selector(longPress:)];
        [btn addGestureRecognizer:longPress];
    }
    
}
//长按抖动的方法
+(void)longPress:(UILongPressGestureRecognizer*)longPress
{
    if (longPress.state==UIGestureRecognizerStateBegan)
    {
        //创建动画 给按钮动画
        CAKeyframeAnimation* anim=[CAKeyframeAnimation animation];
        anim.keyPath=@"transform.rotation";
        anim.values=@[@(angelToRandian(-1)),@(angelToRandian(1)),@(angelToRandian(-1))];
        anim.repeatCount=MAXFLOAT;
        anim.duration=0.2;
        
        for (UIButton*btn in gongyongmarr) {
            
            btn.layer.speed=1.0;
            [btn.layer addAnimation:anim forKey:nil];
            
            //创建一个删除按钮当抖动的时候浮现出来能删除图标
            UIButton*shanchubtn=[UIButton buttonWithType:UIButtonTypeCustom];
            shanchubtn.frame=CGRectMake(0,0, 20, 20);
            [shanchubtn setImage:[UIImage imageNamed:@"903986841.jpeg"] forState:UIControlStateNormal];
            [btn addSubview:shanchubtn];
            [shanchumarr addObject:shanchubtn];
            
            [shanchubtn addTarget:self action:@selector(shanchu:) forControlEvents:UIControlEventTouchUpInside];
        }
    }
}
//删除方法
+(void)shanchu:(UIButton*)shanchubtn
{
    [shanchubtn.superview removeFromSuperview];
    //[shanchubtn removeFromSuperview];
}


#pragma mark--暂停动画
+(void)tingzhi:(NSMutableArray*)marr
{
    gongyongmarr=[[NSMutableArray alloc]init];
    gongyongmarr=marr;
    for (UIButton*btn in gongyongmarr)
    {
        
//        CFTimeInterval pausedTime = [btn.layer convertTime:CACurrentMediaTime() fromLayer:nil];
        btn.layer.speed=0.0;
        
        //清除视图的子视图
        for(UIButton*btn in shanchumarr)
        {
            [btn removeFromSuperview];
        }
    }
    
}

@end
